      module mesh     
      use bh02

      contains
      
      subroutine allocate_grid(grid,grid_name,gmin,gmax,gd)
      type(GF3TL), pointer        ::  grid 
      character(256),target       ::  grid_name
      real, array(3)            ::  gmin,gmax,gd 
      real temp1,temp2,temp3
      
      integer nx,ny,nz

      INTERFACE
      subroutine initialize_coordinates(x,y,z,nx,ny,nz,dx,dy,dz)
      real, dimension(:) :: x,y,z
c      real, dimension(3) :: gmin,gd
      real                 :: dx,dy,dz
      integer              :: nx,ny,nz
      end subroutine initialize_coordinates

c      subroutine allocate_GF3TL(grid,grid_name)
c      type(GF3TL), pointer        ::  grid 
c      character(256),target       :: grid_name
c      end subroutine allocate_GF3TL

c      subroutine allocate_GF3(grid,nx,ny,nz) 
c      type(GF3TL), pointer ::  grid 
c      integer nx,ny,nz
c      end subroutine allocate_GF3

c      subroutine allocate_coordinates(grid,nx,ny,nz)
c      type(GF3TL), pointer ::  grid 
c      integer nx,ny,nz
c      end subroutine allocate_coordinates

      END INTERFACE

c      temp1=((gmax(1)-gmin(1))/gd(1))
      nx=((gmax(1)-gmin(1))/gd(1)) + 1.5
      ny=((gmax(2)-gmin(2))/gd(2)) + 1.5
      nz=((gmax(3)-gmin(3))/gd(3)) + 1.5
c      write(6,*) 'nx=',nx,'ny=',ny,'nz=',nz
c      write(6,*) 'xmax', gmax(1),'xmin',gmin(1)
c      write(6,*) 'ymax', gmax(2),'ymin',gmin(2)
c      write(6,*) 'zmax', gmax(3),'zmin',gmin(3)

c      write(6,*) 'gd(1)',gd(1),'gd(2)',gd(2),'gd(3)',gd(3)
c      write(6,*) 'gd(1)' ,gd(1),'gd(2)',gd(2),'gd(3)',gd(3)
      dx = 0.2
      dy = 0.2
      dz = 0.2    
c      write(6,*) 'calling allocate_GF3TL'
      call allocate_GF3TL(grid,grid_name)
c      write(6,*) 'calling allocate_GF3'
      call allocate_GF3(grid,nx,ny,nz)
c      write(6,*) 'calling allocate_coordinates'
      call allocate_coordinates(grid,nx,ny,nz)
c      write(6,*) 'calling initialize_coordinates'
      call initialize_coordinates(
     & grid%gfcn(1)%tlev(1)%c(1)%coord,
     & grid%gfcn(1)%tlev(1)%c(2)%coord,
     & grid%gfcn(1)%tlev(1)%c(3)%coord,
     & nx,ny,nz,dx,dy,dz)
c       write(6,*) 'end allocate_grid'
      return
      end subroutine allocate_grid 

      subroutine allocate_GF3TL(grid,grid_name)
      type(GF3TL), pointer        ::  grid 
      character(256),target       :: grid_name

      allocate(grid,stat=ierr)
      if(ierr>0) then
       write(6,*) 'allocate_GF3TL(1): not enough memeory'
       stop
      endif 
      grid % name = trim(grid_name)
      grid % n_gfcn = n_gfcn
      allocate(grid % gfcn(n_gfcn),stat=ierr)
      if(ierr>0) then
       write(6,*) 'allocate_GF3TL(2): not enough memeory'
       stop
      endif 

      do i = 1, grid % n_gfcn
         grid % gfcn(i) % n_t = ntlev(i)
         allocate(grid % gfcn(i) % t(ntlev(i)),stat=ierr)
         if(ierr>0) then
         write(6,*) 'allocate_GF3TL(3): not enough memeory'
         stop
         endif 

         allocate(grid % gfcn(i) % tlev(ntlev(i)),stat=ierr)
         if(ierr>0) then
         write(6,*) 'allocate_GF3TL(4): not enough memeory'
         stop
        endif 

      enddo 
      return
      end subroutine allocate_GF3TL

      subroutine allocate_GF3(grid,nx,ny,nz) 
      type(GF3TL), pointer ::  grid 
      integer nx,ny,nz

       do i = 1, n_gfcn
        do j= 1, grid % gfcn(i) % n_t  
          grid % gfcn(i) % tlev(j) % name => gnames(i) 
          allocate(grid % gfcn(i) % tlev(j) % ddim(3),stat=ierr)
          if(ierr>0) then
          write(6,*) 'allocate_GF3(1): not enough memeory'
          stop
          endif 

          grid % gfcn(i) % tlev(j) % ddim = (/nx,ny,nz/)
          allocate(grid % gfcn(i) % tlev(j) % data(nx,ny,nz),stat=ierr)
          if(ierr>0) then
          write(6,*) 'allocate_GF3(2): not enough memeory'
          stop
          endif 
          grid%gfcn(i)%tlev(j)%data=0

          allocate(grid % gfcn(i) % tlev(j) % c(3),stat=ierr)
          if(ierr>0) then
          write(6,*) 'allocate_GF3(3): not enough memeory'
          stop
          endif 

       enddo  
      enddo  
      return
      end subroutine allocate_GF3

      subroutine allocate_coordinates(grid,nx,ny,nz)
      type(GF3TL), pointer ::  grid 
      integer nx,ny,nz

      type(COORDS), pointer :: x,y,z

      allocate(x,stat=ierr)
      if(ierr>0) then
       write(6,*) 'allocate_coordinates(1): not enough memeory'
       stop
      endif 

      x%n_coord=nx
c      write(6,*) 'nx', nx
      allocate(x % coord(nx),stat=ierr)      
      if(ierr>0) then
       write(6,*) 'allocate_coordinates(2): not enough memeory'
       stop
      endif 
      allocate(y,stat=ierr)
      if(ierr>0) then
       write(6,*) 'allocate_coordinates(3): not enough memeory'
       stop
      endif 

      y%n_coord=ny
      allocate(y % coord(ny),stat=ierr)
      if(ierr>0) then
       write(6,*) 'allocate_coordinates(4): not enough memeory'
       stop
      endif 
      
      allocate(z,stat=ierr)
      if(ierr>0) then
       write(6,*) 'allocate_coordinates(5): not enough memeory'
       stop
      endif 

      z%n_coord=nz
      allocate(z % coord(nz),stat=ierr)
      if(ierr>0) then
       write(6,*) 'allocate_coordinates(6): not enough memeory'
       stop
      endif 
      
      
       do i=1,grid%n_gfcn
        do j=1,grid%gfcn(i)%n_t
         grid % gfcn(i) % tlev(j) % c(1) = x
         grid % gfcn(i) % tlev(j) % c(2) = y
         grid % gfcn(i) % tlev(j) % c(3) = z
        end do
       end do

       return
      end subroutine allocate_coordinates

      subroutine deallocateGF3TL(struct) 
      type(GF3TL), pointer ::  struct 
      integer n_t,n,igfcn,i_t 

      n=struct%n_gfcn
      do igfcn=1,n
        n_t=struct%gfcn(igfcn)%n_t
        do i_t=1,n_t
           deallocate(struct%gfcn(igfcn)%tlev(i_t))
        enddo
      enddo

      do igfcn=1,n
        deallocate(struct%gfcn(igfcn))
      enddo

      deallocate(struct)
      nullify(struct)
      return
      end subroutine deallocateGF3TL

      subroutine copyGF3TL(struct,copy)
      type(GF3TL), pointer ::  struct,copy 
      integer n_gfcn,ndim,n_t
     
      ndim=3
      n_gfcn=struct%n_gfcn

      allocate(copy,stat=ierr)
      if(ierr>0) then
       write(6,*) 'copyGF3TL(1): not enough memeory'
       stop
      endif 

      copy%name = struct%name
      copy%n_gfcn=struct%n_gfcn
      allocate(copy%gfcn(n_gfcn),stat=ierr)
      if(ierr>0) then
       write(6,*) 'copyGF3TL(2): not enough memeory'
       stop
      endif 

      do i=1, n_gfcn 
         copy%gfcn(i)%n_t = struct%gfcn(i)%n_t
         n_t=struct%gfcn(i)%n_t
         allocate(copy % gfcn(i) % t(n_t),stat=ierr)
         if(ierr>0) then
         write(6,*) 'copyGF3TL(2): not enough memeory'
         stop
         endif 

         allocate(copy % gfcn(i) % tlev(n_t),stat=ierr)
         if(ierr>0) then
         write(6,*) 'copyGF3TL(3): not enough memeory'
         stop
         endif 


         do j=1,copy%gfcn(i)%n_t
            copy%gfcn(i)%t(j)=struct%gfcn(i)%t(j)
         enddo
       enddo


       do i = 1, n_gfcn
        do j= 1, copy % gfcn(i) % n_t
          copy % gfcn(i) % tlev(j) % name =>
     +    struct % gfcn(i) % tlev(j) % name  
          allocate(copy % gfcn(i) % tlev(j) % ddim(ndim),stat=ierr)
          if(ierr>0) then
          write(6,*) 'copyGF3TL(4): not enough memeory'
          stop
          endif 

          copy % gfcn(i) % tlev(j) % ddim = 
     +    struct % gfcn(i) % tlev(j) % ddim
          nx=struct%gfcn(i)%tlev(j)%ddim(1)
          ny=struct%gfcn(i)%tlev(j)%ddim(2)
          nz=struct%gfcn(i)%tlev(j)%ddim(3)
          allocate(copy % gfcn(i) % tlev(j) % 
     +                                    data(nx,ny,nz),stat=ierr)
          if(ierr>0) then
          write(6,*) 'copyGF3TL(5): not enough memeory'
          stop
          endif 
          copy % gfcn(i) % tlev(j) % data = 
     +    struct % gfcn(i) % tlev(j) % data

          allocate(copy % gfcn(i) % tlev(j) % c(3),stat=ierr)
          if(ierr>0) then
          write(6,*) 'copyGF3TL(6): not enough memeory'
          stop
          endif 
              
          copy % gfcn(i) % tlev(j) % c = 
     +    struct % gfcn(i) % tlev(j) % c
       enddo  
      enddo  
      return 
      end subroutine copyGF3TL

      subroutine vGF3TL(struct)
      type(GF3TL) struct

c     verify structure GF3TL  

      write(6,*) '======= new structure ======'
      write(6,*) 'name: ',trim(struct%name)
      write(6,*) 'number of grid functions:',struct%n_gfcn
      if(struct%n_gfcn.le.0) stop
      do i=1,struct%n_gfcn
       write(6,*) '--> gfcn',i,' time levels:',struct%gfcn(i)%n_t
       do j=1,struct%gfcn(i)%n_t
       write(6,*) '    tl',j,' timeid:',struct%gfcn(i)%t(j)
       write(6,*) '       gfnc name:',trim(struct%gfcn(i)%tlev(j)%name)
       write(6,*) '       gfnc ddim:',struct%gfcn(i)%tlev(j)%ddim
       write(6,*) '       coordinates'
       if(.not.associated(struct%gfcn(i)%tlev(j)%c(1)%coord)) then
           write(6,*) '     coordinates not initialized !!!!'
           cycle
       else
           write(6,*) 'nr=',struct%gfcn(i)%tlev(j)%c(1)%n_coord
           write(6,*) struct%gfcn(i)%tlev(j)%c(1)%coord(1:4)
       endif
       enddo
      enddo
      write(6,*) '===end of new structure ==='
      return
      end subroutine vGF3TL
      

      end module mesh








